/*
*  Copyright (C) 2000 Brian Harris, Mark Liffiton
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2, or (at your option)
*  any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#define BOOKMARKS_TITLE_LEN 64
#define _Tr(x) kPlugin.kFuncs->Translate(x)
#define _Q(x) #x
#define PLUGIN_NAME "Netscape Bookmark Plugin"

#define PREFERENCE_BOOKMARK_FILE   "kmeleon.plugins.bookmarks.bookmarkFile"
#define PREFERENCE_TOOLBAR_FOLDER  "kmeleon.plugins.bookmarks.toolbarFolder"
#define PREFERENCE_TOOLBAR_ENABLED "kmeleon.plugins.bookmarks.toolbarEnabled"
#define PREFERENCE_CHEVRON_ENABLED "kmeleon.plugins.bookmarks.chevron"
#define PREFERENCE_MAX_MENU_LENGTH "kmeleon.plugins.bookmarks.maxMenuLength"
#define PREFERENCE_MENU_AUTODETECT "kmeleon.plugins.bookmarks.menuAutoDetect"
#define PREFERENCE_MAX_TB_SIZE     "kmeleon.plugins.bookmarks.maxToolbarSize"
#define PREFERENCE_EDIT_DLG_LEFT   "kmeleon.plugins.bookmarks.editdialog.left"
#define PREFERENCE_EDIT_DLG_TOP    "kmeleon.plugins.bookmarks.editdialog.top"
#define PREFERENCE_EDIT_DLG_WIDTH  "kmeleon.plugins.bookmarks.editdialog.width"
#define PREFERENCE_EDIT_DLG_HEIGHT "kmeleon.plugins.bookmarks.editdialog.height"
#define PREFERENCE_EDIT_ZOOM       "kmeleon.plugins.bookmarks.editdialog.zoom"
#define PREFERENCE_EDIT_MAX        "kmeleon.plugins.bookmarks.editdialog.maximized"
#define PREFERENCE_SETTINGS_DIR    "kmeleon.general.settingsDir"
#define PREFERENCE_BOOKMARKS_OPENURL "kmeleon.plugins.bookmarks.openurl"
#define PREFERENCE_BOOKMARK_ASKFOLDER "kmeleon.plugins.bookmarks.askforFolder"

#define BOOKMARK_TAG "<!DOCTYPE NETSCAPE-Bookmark-file-1>"
#define KMELEON_TAG "<!-- Generated By KMeleon -->"
#define COMMENT_TAG "<!-- This is an automatically generated file.\nIt will be read and overwritten.\nDo Not Edit! -->"
// #define CONTENT_TYPE_TAG "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=UTF-8\">"
#define CONTENT_TYPE_TAG "<META HTTP-EQUIV=\"Content-Type\""

#define BOOKMARKS_DEFAULT_FILENAME _T("bookmarks.html")
#define BOOKMARKS_FILTER _T("Bookmark Files|bookmark.htm;bookmarks.html;bookmark.htm|HTML Files|*.htm;*.html|")
#define BOOKMARKS_DEFAULT_TITLE _T("Bookmarks")
#define BOOKMARKS_NOT_FOUND _T("Your existing bookmarks file could not be found.\n\n") \
                            _T("Would you like to locate this file now?\n\n") \
                            _T("(Press No to create a new bookmarks file)")
#define BOOKMARKS_CREATING_NEW _T("K-Meleon will create a new, empty bookmark file for you")
#define BOOKMARKS_NOT_BY_US _T("The Bookmarks file was not created by this plugin.  Would you like to save your changes?")
#define BOOKMARKS_SAVE_CHANGES _T("Would you like to save your changes?")
#define BOOKMARKS_CANCEL_CHANGES _T("Warning: all changes will be lost. Are you sure you want to close the bookmark editor?")
#define BOOKMARKS_CANCEL_CAPTION _T("Close Bookmarks Editor")

#define TOOLBAND_NAME "Bookmarks"
#define TOOLBAND_FAILED_TO_CREATE _T("Failed to create bookmark toolbar")
#define TOOLBAND_MAX_BUTTONS  42    // this seems like as good a number as any

#define IMAGE_BLANK         -1
#define IMAGE_FOLDER_CLOSED 0
#define IMAGE_FOLDER_OPEN   1
#define IMAGE_BOOKMARK      2
#define IMAGE_CHEVRON       3
#define IMAGE_FOLDER_SPECIAL_CLOSED 4
#define IMAGE_FOLDER_SPECIAL_OPEN   5

